
#ifndef MEMORYALIAS_H
#define MEMORYALIAS_H

#include "Memory.h"

class MemoryAlias : public Memory
{
    public:
        MemoryAlias() {};
        void init(Memory* m, INT32 location);
        void reset();
        void setVisible(BOOL visible);
        BOOL isVisible();
        INT32 getLocation();
        INT32 peek(INT32 location);
        void poke(INT32 location, INT32 value);
        INT32 getSize();
/*
    void save(SaveOutputStream sos) throws IOException {
    void load(LoadInputStream lis) throws IOException {
*/

    private:
        Memory* aliasedMemory;
        INT32     location;
        INT32     offset;
        BOOL    visible;
    
};

#endif
