
#ifndef MICROSEQUENCER_REGISTERS_H
#define MICROSEQUENCER_REGISTERS_H

#include <windows.h>
#include "Memory.h"

class MicroSequencer;

class MicroSequencer_Registers : public Memory
{

    friend class MicroSequencer;

    public:
        INT32 getSize();
        INT32 getLocation();
        void reset();
        void poke(INT32 location, INT32 value);
        INT32 peek(INT32 location);
/*
        void save(SaveOutputStream sos)
        void load(LoadInputStream lis)
*/

    private:
        MicroSequencer_Registers();
        MicroSequencer_Registers(MicroSequencer* ms);
        void init(MicroSequencer* ms);
        MicroSequencer*  ms;

};

#endif
